function [pvalue, dlogp, MCsample] = LR_simple_simple_MC(null, alter, x, nMC)
% Simple vs. simple likelihood ratio test using Monte Carlo. 
% 

if isa(null, 'gmdistribution')
    MCsample=zeros(nMC,1);
    Nx = size(x,1);
    xsimuAll = random(null, Nx*nMC);        
    for i = 1:nMC
        xsimu = xsimuAll( ((i-1)*Nx+1) : i*Nx, : );
        MCsample(i)= - sum(log(pdf(null, xsimu))) + sum(log(pdf(alter, xsimu)));
    end
    dlogp = - sum(log(pdf(null, x))) + sum(log(pdf(alter, x)));    
    pvalue = mean(dlogp <= MCsample);    



elseif isa(null, 'gbrbm')
    MCsample=zeros(nMC,1);
    Nx = size(x,1);
    xsimuAll = ExactSampler(null, Nx*nMC);        

    for i = 1:nMC
        xsimu = xsimuAll( ((i-1)*Nx+1) : i*Nx, : );
    %    MCsample(i)= - sum(logMarginalLikelihood(null, xsimu)) + sum(logMarginalLikelihood(alter, xsimu));
        MCsample(i)= - sum(logMarginalUnormalizedLikelihood(null, xsimu)) + sum(logMarginalUnormalizedLikelihood(alter, xsimu));
    end


    dlogp = - sum(logMarginalUnormalizedLikelihood(null, x)) + sum(logMarginalUnormalizedLikelihood(alter, x));
    %dlogp = - sum(logMarginalLikelihood(null, x)) + sum(logMarginalLikelihood(alter, x));


    logZ = (-logPartitionFunction(null) + logPartitionFunction(alter))*Nx;
    dlogp = dlogp - logZ;
    MCsample = MCsample - logZ;

    pvalue = mean(dlogp <= MCsample);
end