function args = change_varargin(args, varargin)
%ARGFILTER  Remove unwanted arguments.
% change_varargin(ARGS, varargin), where ARGS an CHANGE are in the form of {'arg1',value1,'arg2',value2,...},
% returns a new argument list where the arguments named in CHANGE are changed to the values specified in CHANGE
%    --- if arg1 is in args and in varargin, change the value to the one in varargin
%    --- if arg1 is not in args, do nothing
%
% Written by Qiang Liu


if ~iscell(varargin)
    error('the second variable has to be cell');
end
if mod(length(args), 2) || mod(length(varargin),2)
   error('The number of elements in the Input has to be even'); 
end

change_names = varargin(1:2:end-1); args_names = args(1:2:end-1);

for i = 1:length(change_names)
   dx = find(strcmpi(change_names{i},args_names));
   if dx
       args{2*dx} = varargin{2*i};
   end
end
  

return;
end
