function  Y = fieldsup(X, alltomat)
% Inputs: X{i,j}.a, X{i,j}.b ==> Outputs: X.a(i,j), X.b(i,j) (or X.b{i,j} if numel(b)>1)
%
%
% Qiang Liu @ 03/2015
%%

if ~exist('alltomat','var'), alltomat = 0; end

% If X is a cell
if isa(X, 'cell')
    
fdnames=fieldnames(X{1});
sz = size(X);    
for i = 1:length(fdnames)
    fd = fdnames{i};    
    if numel(X{1}.(fd))==1
        tmp = zeros(sz);
        for k = 1:numel(X)
            tmp(k) = X{k}.(fd);
        end
        Y.(fd) = tmp;    
    else
        tmp = cell(sz);
        for k = 1:numel(X)
            tmp{k} = X{k}.(fd);
        end
        Y.(fd) = tmp;
        try if alltomat, Y.(fd)=cell2mat(Y.(fd)); end;end
    end    
end

return;
end

%%
% If X is a struct, do the same thing
if isa(X, 'struct')
    
fdnames=fieldnames(X(1));
sz = size(X);    
for i = 1:length(fdnames)
    fd = fdnames{i};    
    if numel(X(1).(fd))==1
        tmp = zeros(sz);
        for k = 1:numel(X)
            tmp(k) = X(k).(fd);
        end
        Y.(fd) = tmp;    
    else
        tmp = cell(sz);
        for k = 1:numel(X)
            tmp{k} = X(k).(fd);
        end
        Y.(fd) = tmp;
        try if alltomat, Y.(fd)=cell2mat(Y.(fd)); end;end
    end
end
return;

end


