function ndx = mysub2ind(siz,IJ)

siz = double(siz);
if length(siz)<2
        error('MATLAB:sub2ind:InvalidSize',...
            'Size vector must have at least 2 elements.');
end

%Adjust input
%if length(siz)<=nargin-1
%    %Adjust for trailing singleton dimensions
%    siz = [siz ones(1,nargin-length(siz)-1)];
%else
    %Adjust for linear indexing on last element
%    siz = [siz(1:nargin-2) prod(siz(nargin-1:end))];
%end

%Compute linear indices
k = [1 cumprod(siz(1:end-1))];
ndx = 1;
for i = 1:length(siz),
    v = IJ(:, i);
    %%Input checking
    if (any(v(:) < 1)) || (any(v(:) > siz(i)))
        %Verify subscripts are within range
        error('MATLAB:sub2ind:IndexOutOfRange','Out of range subscript.');
    end
    ndx = ndx + (v-1)*k(i);
end
