function [h, median_dist, median_sqxx] = ratio_median_heuristic(Z, score_q)
% heuristic choosing bandwidth in KSD with RBF kernel
% 
    size1 = size(Z,1);
    if size1>100
      Zmed = Z(randperm(size1,100),:);
      size1 = 100;
    else
      Zmed = Z;
    end
    G = sum((Zmed.*Zmed),2);
    Q = repmat(G,1,size1);
    R = repmat(G',size1,1);
    dists = Q + R - 2*Zmed*Zmed';
    dists = dists-tril(dists);
    dists=reshape(dists,size1^2,1);
    median_dist = median(dists(dists>0));
    %params.sig = sqrt(0.5*median(dists(dists>0)));  %rbf_dot has factor two in kernel
        
    sqx = score_q(Zmed);
    sqxx =sqx*sqx';
    sqxx = sqxx-tril(sqxx);
    sqxx=reshape(sqxx,size1^2,1);
    median_sqxx = median(sqxx(sqxx>0));
    
    h = (median_dist/median_sqxx)^(1/4);
    
    
    
    %dists=reshape(dists,size1^2,1);
    %median_dist = median(dists(dists>0));
    %params.sig = sqrt(0.5*median(dists(dists>0)));  %rbf_dot has factor two in kernel

