function  [Kxy, dxKxy, dyKxy, dxyKxy]=rbf_with_scores(x, y, h)
% x: size NumInstance X NumDimension



x = x(:); y = y(:);

n1=size(x,1); n2 = size(y,1); p = size(x,2);

XY = x*y';
X2e = repmat(sum(x.^2, 2), 1, n2);
xe = repmat(x, 1, n2);

Y2e = repmat(sum(y.^2,2), 1, n1);
ye = repmat(y, 1, n1);

H = (X2e + Y2e' - 2*XY);
Kxy = exp(-H/(2*h^2));
dxKxy = Kxy.*(ye' - xe)/(h^2);
dyKxy = -dxKxy;
dxyKxy = Kxy.*(-H/h^4 + 1/h^2);

%{
n=size(x,1); p = size(x,2);

XY = x*x';
x2= sum(x.^2, 2);
X2e = repmat(x2, 1, n);
xe = repmat(x, 1, n);

H = (X2e + X2e' - 2*XY);
Kxy = exp(-H/(2*h^2));
dxKxy = Kxy.*(xe' - xe)/(h^2);
dyKxy = -dxKxy;
dxyKxy = Kxy.*(-H/h^4 + 1/h^2);
%}

return;
end




%{
function [H]=rbf_dot(patterns1,patterns2,deg)

%Note : patterns are transposed for compatibility with C code.

size1=size(patterns1);
size2=size(patterns2);

%new vectorised version

G = sum((patterns1.*patterns1),2);
H = sum((patterns2.*patterns2),2);

Q = repmat(G,1,size2(1));
R = repmat(H',size1(1),1);

H = Q + R - 2*patterns1*patterns2';


H=exp(-H/2/deg^2);

%old version

if 0 
H=zeros(size1(1),size2(1));
for k=1:size1(1)
  for l=1:size2(1)
    H(k,l)=(patterns1(k,:)-patterns2(l,:))*(patterns1(k,:)-patterns2(l,:))';
  end
end
end


return;
end
%}